> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Join AI Assistant Conversation

> Add a participant to an existing AI assistant conversation. Use this command to bring an additional call leg into a running AI conversation.



## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/call-control-commands/ai-assistant-join.yml post /calls/{call_control_id}/actions/ai_assistant_join
openapi: 3.1.0
info:
  title: Telnyx Call Control - AI Assistant Join
  version: 2.0.0
  description: >-
    API for joining an AI Assistant to an existing conversation on a different
    call leg.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
tags:
  - name: Command
    description: Call control command operations
paths:
  /calls/{call_control_id}/actions/ai_assistant_join:
    post:
      tags:
        - Call Commands
      summary: Join AI Assistant Conversation
      description: >-
        Add a participant to an existing AI assistant conversation. Use this
        command to bring an additional call leg into a running AI conversation.
      operationId: CallJoinAIAssistant
      parameters:
        - $ref: '#/components/parameters/CallControlId'
      requestBody:
        description: AI Assistant Join request
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AIAssistantJoinRequest'
      responses:
        '200':
          $ref: '#/components/responses/CallControlCommandResponseWithConversationId'
        '422':
          $ref: '#/components/responses/UnprocessableEntityResponse'
        default:
          $ref: '#/components/responses/call-control_GenericErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            const response = await
            client.calls.actions.joinAIAssistant('call_control_id', {
              conversation_id: 'v3:abc123',
              participant: { id: 'v3:abc123def456', role: 'user' },
            });


            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            response = client.calls.actions.join_ai_assistant(
                call_control_id="call_control_id",
                conversation_id="v3:abc123",
                participant={
                    "id": "v3:abc123def456",
                    "role": "user",
                },
            )
            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.Calls.Actions.JoinAIAssistant(\n\t\tcontext.TODO(),\n\t\t\"call_control_id\",\n\t\ttelnyx.CallActionJoinAIAssistantParams{\n\t\t\tConversationID: \"v3:abc123\",\n\t\t\tParticipant: telnyx.CallActionJoinAIAssistantParamsParticipant{\n\t\t\t\tID:   \"v3:abc123def456\",\n\t\t\t\tRole: \"user\",\n\t\t\t},\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.calls.actions.ActionJoinAiAssistantParams;

            import
            com.telnyx.sdk.models.calls.actions.ActionJoinAiAssistantResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    ActionJoinAiAssistantParams params = ActionJoinAiAssistantParams.builder()
                        .callControlId("call_control_id")
                        .conversationId("v3:abc123")
                        .participant(ActionJoinAiAssistantParams.Participant.builder()
                            .id("v3:abc123def456")
                            .role(ActionJoinAiAssistantParams.Participant.Role.USER)
                            .build())
                        .build();
                    ActionJoinAiAssistantResponse response = client.calls().actions().joinAiAssistant(params);
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            response = telnyx.calls.actions.join_ai_assistant(
              "call_control_id",
              conversation_id: "v3:abc123",
              participant: {id: "v3:abc123def456", role: :user}
            )

            puts(response)
        - lang: CLI
          source: |-
            telnyx calls:actions join-ai-assistant \
              --api-key 'My API Key' \
              --call-control-id call_control_id \
              --conversation-id v3:abc123 \
              --participant '{id: v3:abc123def456, role: user}'
components:
  parameters:
    CallControlId:
      name: call_control_id
      description: Unique identifier and token for controlling the call
      in: path
      required: true
      schema:
        type: string
  schemas:
    AIAssistantJoinRequest:
      type: object
      required:
        - conversation_id
        - participant
      properties:
        conversation_id:
          type: string
          description: The ID of the AI assistant conversation to join.
          example: v3:abc123
        participant:
          $ref: '#/components/schemas/AIAssistantJoinParticipant'
        client_state:
          type: string
          description: >-
            Use this field to add state to every subsequent webhook. It must be
            a valid Base-64 encoded string.
          example: aGF2ZSBhIG5pY2UgZGF5ID1d
        command_id:
          type: string
          description: >-
            Use this field to avoid duplicate commands. Telnyx will ignore any
            command with the same `command_id` for the same `call_control_id`.
          example: 891510ac-f3e4-11e8-af5b-de00688a4901
    AIAssistantJoinParticipant:
      type: object
      required:
        - id
        - role
      properties:
        id:
          type: string
          description: The call_control_id of the participant to add to the conversation.
          example: v3:abc123def456
        role:
          type: string
          description: The role of the participant in the conversation.
          enum:
            - user
          example: user
        name:
          type: string
          description: Display name for the participant.
          example: John Doe
        on_hangup:
          type: string
          description: >-
            Determines what happens to the conversation when this participant
            hangs up.
          enum:
            - continue_conversation
            - end_conversation
          default: continue_conversation
          example: continue_conversation
    CallControlCommandResultWithConversationId:
      type: object
      title: Call Control Command Result With Conversation ID
      example:
        result: ok
        conversation_id: d7e9c1d4-8b2a-4b8f-b3a7-9a671c9e9b0a
      properties:
        result:
          type: string
          example: ok
        conversation_id:
          type: string
          format: uuid
          example: d7e9c1d4-8b2a-4b8f-b3a7-9a671c9e9b0a
          description: The ID of the conversation created by the command.
    call-control_Errors:
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/call-control_Error'
    call-control_Error:
      required:
        - code
        - title
      properties:
        code:
          type: string
          format: integer
        title:
          type: string
        detail:
          type: string
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
              format: json-pointer
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
  responses:
    CallControlCommandResponseWithConversationId:
      description: >-
        Successful response upon making a call control command that includes
        conversation_id.
      content:
        application/json:
          schema:
            type: object
            title: Call Control Command Response With Conversation ID
            properties:
              data:
                $ref: >-
                  #/components/schemas/CallControlCommandResultWithConversationId
    UnprocessableEntityResponse:
      description: >-
        Unprocessable entity. The request was well-formed but could not be
        processed due to semantic errors. This includes validation errors,
        invalid parameter values, call state errors, conference errors, queue
        errors, recording/transcription errors, and business logic violations.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/call-control_Errors'
          examples:
            missing_required_parameter:
              summary: Missing required parameter
              value:
                errors:
                  - code: '10004'
                    title: Missing required parameter
                    detail: The 'to' parameter is required and cannot be blank.
                    source:
                      pointer: /to
            invalid_call_control_id:
              summary: Invalid call control ID
              value:
                errors:
                  - code: '90015'
                    title: Invalid Call Control ID
                    detail: The call_control_id provided was not valid.
                    source:
                      pointer: /call_control_id
            call_already_ended:
              summary: Call has already ended
              value:
                errors:
                  - code: '90018'
                    title: Call has already ended
                    detail: This call is no longer active and can't receive commands.
            call_not_answered:
              summary: Call not answered yet
              value:
                errors:
                  - code: '90034'
                    title: Call not answered yet
                    detail: >-
                      This call can't receive this command because it has not
                      been answered yet.
            cannot_record_before_audio_started:
              summary: Cannot record before audio started
              value:
                errors:
                  - code: '90020'
                    title: Call recording triggered before audio started
                    detail: >-
                      Call recording cannot be started until audio has commenced
                      on the call.
            transcription_already_active:
              summary: Transcription already active
              value:
                errors:
                  - code: '90054'
                    title: Call transcription is already in progress
                    detail: Call transcription can not be started more than once.
            ai_assistant_already_active:
              summary: AI Assistant already active
              value:
                errors:
                  - code: '90061'
                    title: AI Assistant is already in progress
                    detail: AI Assistant cannot be started more than once.
            conference_already_ended:
              summary: Conference has already ended
              value:
                errors:
                  - code: '90019'
                    title: Conference has already ended
                    detail: >-
                      This conference is no longer active and can't receive
                      commands.
            conference_name_conflict:
              summary: Conference name conflict
              value:
                errors:
                  - code: '90033'
                    title: Unable to execute command
                    detail: Conference with given name already exists and it's active.
            max_participants_reached:
              summary: Maximum participants reached
              value:
                errors:
                  - code: '90032'
                    title: Maximum number of participants reached
                    detail: >-
                      The maximum allowed value of `max_participants` has been
                      reached at 100.
            queue_full:
              summary: Queue is full
              value:
                errors:
                  - code: '90036'
                    title: Queue full
                    detail: The 'support' queue is full and can't accept more calls.
            call_already_in_queue:
              summary: Call already in queue
              value:
                errors:
                  - code: '90038'
                    title: Call already in queue
                    detail: Call can't be added to a queue it's already in.
            invalid_connection_id:
              summary: Invalid connection ID
              value:
                errors:
                  - code: '10015'
                    title: Invalid value for connection_id (Call Control App ID)
                    detail: >-
                      The requested connection_id (Call Control App ID) is
                      either invalid or does not exist. Only Call Control Apps
                      with valid webhook URL are accepted.
                    source:
                      pointer: /connection_id
            invalid_phone_number_format:
              summary: Invalid phone number format
              value:
                errors:
                  - code: '10016'
                    title: Phone number must be in +E164 format
                    detail: The 'to' parameter must be in E164 format.
                    source:
                      pointer: /to
            srtp_not_supported_for_pstn:
              summary: SRTP not supported for PSTN calls
              value:
                errors:
                  - source:
                      pointer: /media_encryption
                    title: Media encryption not supported for PSTN calls
                    detail: SRTP media encryption is not supported for PSTN calls.
                    code: '10011'
            fork_not_found:
              summary: Call is not forked
              value:
                errors:
                  - code: '90031'
                    title: Call is not currently forked
                    detail: >-
                      Can't stop forking, because the call isn't currently
                      forked.
            media_streaming_used:
              summary: Media streaming in use
              value:
                errors:
                  - code: '90045'
                    title: Media Streaming is used
                    detail: This command can't be issued when media streaming is used.
            invalid_enumerated_value:
              summary: Invalid enumerated value
              value:
                errors:
                  - code: '10032'
                    title: Invalid enumerated value
                    detail: 'The value must be one of: dual, single.'
                    source:
                      pointer: /record_channels
            value_outside_range:
              summary: Value outside of range
              value:
                errors:
                  - code: '10033'
                    title: Value outside of range
                    detail: The value is outside of allowed range 1 to 5000
                    source:
                      pointer: /max_participants
    call-control_GenericErrorResponse:
      description: Unexpected error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/call-control_Errors'
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````